package ru.dbotthepony.mc.otm.capability.matter;

import net.minecraft.MethodsReturnNonnullByDefault;
import net.minecraft.core.BlockPos;
import net.minecraft.core.Direction;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.entity.BlockEntity;
import ru.dbotthepony.mc.otm.capability.MatteryCapability;
import ru.dbotthepony.mc.otm.matter.MatterGrid;

import javax.annotation.Nullable;
import javax.annotation.ParametersAreNonnullByDefault;

import static ru.dbotthepony.mc.otm.AbstractGrid.createOrConnectGrid;

@MethodsReturnNonnullByDefault
@ParametersAreNonnullByDefault
public interface IMatterGridCell extends IMatterGridListener {
	@Nullable
	MatterGrid getMatterGrid();

	@Nullable
	default IMatterHandler getMatterHandler() {
		return null;
	}

	@Nullable
	default IPatternStorage getPatternStorage() {
		return null;
	}

	@Nullable
	default IMatterTaskProvider getTaskProvider() {
		return null;
	}

	boolean isValidMatterCell();

	void setMatterGrid(@Nullable MatterGrid grid);

	default void scheduleDiscoverNeighbours(Level level, BlockPos pos) {
		MatterGrid.scheduleDiscoverNeighbours(this, pos, level);
	}

	default boolean connectOrCreateMatterGrid(Level level, BlockPos pos) {
		return connectOrCreateMatterGrid(pos, level, false);
	}

	default void onNeighbourMatterCell(Level level, BlockPos pos, Direction direction, IMatterGridCell cell, BlockEntity entity) {

	}

	default boolean connectOrCreateMatterGrid(BlockPos pos, Level level, boolean force) {
		return createOrConnectGrid(
			this,
			MatteryCapability.MATTER_CELL,
			level,
			pos,
			force,
			MatterGrid::new,
			IMatterGridCell::getMatterGrid,
			this::onNeighbourMatterCell
		);
	}
}
