package ru.dbotthepony.mc.otm.capability.matter;

import net.minecraft.MethodsReturnNonnullByDefault;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import javax.annotation.ParametersAreNonnullByDefault;

/**
 * status: FAIL, UPDATED or INSERTED
 * new_state: null if FAIL, the pattern privided for insertion otherwise (or modified copy of it)
 * old_state: on UPDATED, previous state, or null if not UPDATED
 */
public record PatternInsertStatus(@Nonnull Status status, @Nullable PatternState new_state, @Nullable PatternState old_state) {
	public enum Status {
		FAIL,
		UPDATED,
		INSERTED,
	}

	public PatternInsertStatus(@Nonnull Status status, @Nullable PatternState new_state, @Nullable PatternState old_state) {
		this.status = status;
		this.new_state = new_state;
		this.old_state = old_state;
	}

	public PatternInsertStatus() {
		this(Status.FAIL, null, null);
	}

	public PatternInsertStatus(@Nonnull PatternState new_state) {
		this(Status.INSERTED, new_state, null);
	}

	public PatternInsertStatus(@Nonnull PatternState new_state, @Nonnull PatternState old_state) {
		this(Status.UPDATED, new_state, old_state);
	}
}

