package ru.dbotthepony.mc.otm.client.screen.panels;

import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.TextComponent;
import ru.dbotthepony.mc.otm.client.render.RGBAColor;
import ru.dbotthepony.mc.otm.client.screen.MatteryScreen;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

public class Label extends EditablePanel {
	protected Component text = new TextComponent("Label");

	public Label(@Nonnull MatteryScreen<?> screen, @Nullable EditablePanel parent, float x, float y, float width, float height) {
		super(screen, parent, x, y, width, height);
		scissor = true;
	}

	public Label(@Nonnull MatteryScreen<?> screen, @Nullable EditablePanel parent) {
		super(screen, parent);
		scissor = true;
	}

	public Label(@Nonnull MatteryScreen<?> screen, @Nullable EditablePanel parent, float x, float y) {
		super(screen, parent, x, y, 100, 12);
		scissor = true;
	}

	public Label(@Nonnull MatteryScreen<?> screen, @Nullable EditablePanel parent, float x, float y, float width, float height, Component text) {
		super(screen, parent, x, y, width, height);
		scissor = true;
		this.text = text;
	}

	public Label(@Nonnull MatteryScreen<?> screen, @Nullable EditablePanel parent, Component text) {
		super(screen, parent);
		scissor = true;
		this.text = text;
	}

	public Label(@Nonnull MatteryScreen<?> screen, @Nullable EditablePanel parent, float x, float y, Component text) {
		super(screen, parent, x, y, 100, 12);
		scissor = true;
		this.text = text;
	}

	public Component getText() {
		return text;
	}

	public void setText(Component text) {
		this.text = text;
	}

	@Override
	protected void innerRender(PoseStack stack, float mouse_x, float mouse_y, float flag) {
		font().draw(stack, text, 0, 0, RGBAColor.SLATE_GRAY.wholeinv());
	}
}
