package ru.dbotthepony.mc.otm.client.screen.panels;

import com.mojang.blaze3d.vertex.PoseStack;
import ru.dbotthepony.mc.otm.menu.widget.AbstractWidget;
import ru.dbotthepony.mc.otm.client.screen.MatteryScreen;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

public class MatteryWidgetPanel extends EditablePanel {
	public final AbstractWidget widget;

	public MatteryWidgetPanel(@Nonnull MatteryScreen screen, @Nullable EditablePanel parent, AbstractWidget widget) {
		super(screen, parent, widget.x, widget.y, widget.getImageWidth(), widget.getImageHeight());
		widget.x = 0;
		widget.y = 0;
		this.widget = widget;
	}

	public MatteryWidgetPanel(@Nonnull MatteryScreen screen, @Nullable EditablePanel parent, float x, float y, AbstractWidget widget) {
		super(screen, parent, x, y, widget.getImageWidth(), widget.getImageHeight());
		widget.x = 0;
		widget.y = 0;
		this.widget = widget;
	}

	@Override
	protected void innerRender(PoseStack stack, float mouse_x, float mouse_y, float flag) {
		widget.renderBackground(stack, 0, 0);
	}

	@Override
	protected boolean innerRenderTooltips(PoseStack stack, float mouse_x, float mouse_y, float flag) {
		if (is_hovered) {
			var tooltips = widget.getTooltip();

			if (tooltips != null) {
				screen.renderComponentTooltip(stack, tooltips, (int) mouse_x, (int) mouse_y);
				return true;
			}
		}

		return false;
	}
}
