package ru.dbotthepony.mc.otm.menu;

import net.minecraft.world.entity.player.Inventory;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityItemMonitor;
import ru.dbotthepony.mc.otm.menu.data.INetworkedItemViewSupplier;
import ru.dbotthepony.mc.otm.menu.data.NetworkedItemView;
import ru.dbotthepony.mc.otm.storage.ItemStackWrapper;

import javax.annotation.Nonnull;

public class ItemMonitorMenu extends PoweredMatteryMenu implements INetworkedItemViewSupplier {
	public final NetworkedItemView view;

	@Nonnull
	@Override
	public NetworkedItemView getNetworkedItemView() {
		return view;
	}

	public ItemMonitorMenu(int p_38852_, Inventory inventory) {
		this(p_38852_, inventory, null);
	}

	public ItemMonitorMenu(int p_38852_, Inventory inventory, BlockEntityItemMonitor tile) {
		super(Registry.Menus.ITEM_MONITOR, p_38852_, inventory, tile);

		view = new NetworkedItemView(inventory.player, this, tile == null);

		if (tile != null) {
			view.setComponent(tile.cell.getStorageGrid().getVirtualComponent(ItemStackWrapper.class));
		}

		addBatterySlot();
		addInventorySlots();
	}

	@Override
	public void broadcastChanges() {
		super.broadcastChanges();

		view.network();
	}

	@Override
	protected int getWorkingSlotStart() {
		return 0;
	}

	@Override
	protected int getWorkingSlotEnd() {
		return 1;
	}
}
