package ru.dbotthepony.mc.otm.menu;

import net.minecraft.world.Container;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.item.ItemStack;
import ru.dbotthepony.mc.otm.matter.MatterRegistry;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityMatterScanner;
import ru.dbotthepony.mc.otm.menu.slot.MatterySlot;
import ru.dbotthepony.mc.otm.menu.widget.ProgressGaugeWidget;

public class MatterScannerMenu extends PoweredMatteryMenu {
	public MatterScannerMenu(int p_38852_, Inventory inventory) {
		this(p_38852_, inventory, null);
	}

	public MatterySlot input;
	public ProgressGaugeWidget progress;

	public MatterScannerMenu(int p_38852_, Inventory inventory, BlockEntityMatterScanner tile) {
		super(Registry.Menus.MATTER_SCANNER, p_38852_, inventory, tile);

		Container container = tile != null ? tile.input_slot : new SimpleContainer(1);

		input = new MatterySlot(container, 0, 64, 38) {
			@Override
			public boolean mayPlace(ItemStack p_40231_) {
				return MatterRegistry.canDecompose(p_40231_);
			}
		};

		addSlot(input);

		if (tile != null) {
			progress = new ProgressGaugeWidget(this, 88, 38, () -> (float) tile.getWorkProgress(), tile::cantProcessJob);
		} else {
			progress = new ProgressGaugeWidget(this, 88, 38);
		}

		addBatterySlot();

		addInventorySlots();
	}

	@Override
	protected int getWorkingSlotStart() {
		return 0;
	}

	@Override
	protected int getWorkingSlotEnd() {
		return 1;
	}
}
