package ru.dbotthepony.mc.otm.client.screen

import net.minecraft.network.chat.Component
import net.minecraft.network.chat.TextComponent
import net.minecraft.network.chat.TranslatableComponent
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.client.screen.panels.*
import ru.dbotthepony.mc.otm.menu.ChemicalGeneratorMenu

class ChemicalGeneratorScreen(menu: ChemicalGeneratorMenu, inventory: Inventory, title: Component) : MatteryScreen<ChemicalGeneratorMenu>(menu, inventory, title) {
	val burn_time = Label(this, null, TextComponent("GabeN"))

	override fun makeMainFrame(): FramePanel? {
		val frame = super.makeMainFrame()

		val battery = MatteryWidgetPanel(this, frame, menu.energy)
		battery.dock = Dock.LEFT
		burn_time.parent = frame
		burn_time.dock = Dock.TOP

		battery.setDockMargin(0f, 0f, 2f, 0f)

		val grid = FlexGridPanel(this, frame)

		SlotPanel(this, grid, menu.fuel_slot)
		MatteryWidgetPanel(this, grid, menu.progress)

		grid.dock = Dock.FILL
		grid.setDockMargin(0f, 2f, 0f, 0f)

		return frame
	}

	override fun containerTick() {
		super.containerTick()

		burn_time.text = TranslatableComponent("otm.gui.power.burn_time", menu.burn_time.value)
	}
}
